#include "gcdSquared.h"
#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL

#define out(x) "x" << " = " << x << "  "

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6 + 42;
const int mod = 1e9 + 7;

ll inp[MAX_N];

ll myGcd( ll a, ll b ){
    if( a > b ) std::swap( a, b );
    if( !a ) return b;
    return myGcd( b % a, a );
}

int _n;
ll tree[4 * MAX_N];

void build( int l =1, int r =_n , int x= 1 ){
    if( l == r ){
        tree[x] = inp[l];
        return;
    }

    int m = ( l + r ) >> 1;
    build( l, m, 2*x );
    build( m+1, r, 2*x +1 );

    tree[x] = __gcd( tree[2*x], tree[2*x +1] );
}

ll query( int l, int r, int x = 1, int lx = 1, int rx = _n ){
    if( l > rx || lx > r ) return -1;
    if( l <= lx and rx <= r ) return tree[x];

    int m = ( lx + rx ) >> 1;
    ll left = query( l, r, 2*x, lx, m );
    ll right = query( l, r, 2*x +1, m+1, r );

    cerr << " ! " << x << " " << left << " " << right << endl;
    if( left == -1 ) return right;
    if( right == -1 ) return left;
    return __gcd( left, right );
}

void init(int n, const int v[]){
    for( int i=1 ; i <= n ; i++ ) inp[i] = v[i];
    _n = n;
    build();
}
long long getGCD(int a, int b, int c, int l, int r){

    std::vector< int > ind( _n );
    std::iota( ind.begin(), ind.end(), 1 );

    std::random_shuffle( ind.begin(), ind.end () );

    ll currGcd;
    for( int i=0 ; i < 1000 and i < _n ; i++ ){
        ll curr = (ll)a * inp[ind[i]] * ind[ind[i]] + (ll)b * inp[ind[i]] + c;
        if( i == 0 ) currGcd = curr;
        else currGcd = std::__gcd( currGcd, curr );
    }

    return currGcd;
}
