/*
    Nevuzpitano ruso e cveta na kosite
    Silikon v ostata silikon v gurdite
    I parfuima natrapchiv i visoki botushi
    I cigari sled sexa tya obicha da pushi
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 50000 + 10;
const int MAXQ = 200000 + 10;
const int INF  = 2e9;

int n, m, q;
struct Query
{
    int xs, ys, xt, yt, idx;
    friend bool operator < (const Query &a, const Query &b)
    {
        if (a.xt != b.xt) return a.xt < b.xt;
        return a.yt < b.yt;
    }
};

int output[MAXQ];
Query query[MAXQ];

struct Table
{
    int t[MAXN];
    inline int get(const int &row, const int &col)
    {
        return t[(row - 1) * m + col];
    }

    inline void set(const int &row, const int &col, const int &value)
    {
        t[(row - 1) * m + col] = value;
    }
};

Table t, dp;
void print()
{
    for (int i = 1 ; i <= q ; ++i)
    {
        std::cout << output[i] << '\n';
    }
}

void solve()
{
    int ptr = 1;
    std::sort(query + 1, query + 1 + q);
    for (int row = 1 ; row <= n ; ++row)
    {
        for (int col = 1 ; col <= m ; ++col)
        {
            if (ptr > q || query[ptr].xt != row || query[ptr].yt != col)
            {
                continue;
            }

            int ptr2 = ptr;
            int minRow = n + 1;
            int minCol = m + 1;
            while (ptr2 <= q && query[ptr2].xt == row && query[ptr2].yt == col)
            {
                minRow = std::min(minRow, query[ptr2].xs);
                minCol = std::min(minCol, query[ptr2].ys);
                ptr2++;
            }

            for (int i = row ; i >= 1 ; --i)
            {
                for (int j = col ; j >= 1 ; --j)
                {
                    dp.set(i, j, INF);
                    if (i == row && j == col) dp.set(i, j, t.get(i, j));
                    if (i < row) dp.set(i, j, std::min(dp.get(i, j), t.get(i, j) + dp.get(i + 1, j)));
                    if (j < col) dp.set(i, j, std::min(dp.get(i, j), t.get(i, j) + dp.get(i, j + 1)));
                }
            }

            while (ptr <= q && query[ptr].xt == row && query[ptr].yt == col)
            {
                output[query[ptr].idx] = dp.get(query[ptr].xs, query[ptr].ys);
                ptr++;
            }
        }
    }
}

void input()
{
    std::cin >> n >> m >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= m ; ++j)
        {
            int value;
            std::cin >> value;
            t.set(i, j, value);
        }
    }

    for (int i = 1 ; i <= q ; ++i)
    {
        std::cin >> query[i].xs >> query[i].ys >> query[i].xt >> query[i].yt;
        query[i].idx = i;
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();
    print();

    return 0;
}