/*
    Nevuzpitano ruso e cveta na kosite
    Silikon v ostata silikon v gurdite
    I parfuima natrapchiv i visoki botushi
    I cigari sled sexa tya obicha da pushi
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <random>
#include <vector>
#include <set>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

typedef tree <int, std::less <int>, null_type, rb_tree_tag, tree_order_statistics_node_update> OSet;

typedef long long llong;
const int MAXN = 200000 + 10;
const int MAXQ = 200000 + 10;
const int PEOPLE_SIZE = 600;
const int INF  = 2e9;

int n, m, q;
struct Query
{
    int xs, ys, xt, yt, idx;
    friend bool operator < (const Query &a, const Query &b)
    {
        if (a.xt != b.xt) return a.xt < b.xt;
        return a.yt < b.yt;
    }
};

bool isOnPath[MAXN];
std::vector <int> t[MAXN];
std::vector <int> dp[PEOPLE_SIZE][6];
int chosenRow[PEOPLE_SIZE];
int chosenCol[PEOPLE_SIZE];
std::mt19937 rng(69420);

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= m ; ++j)
        {
            isOnPath[(i - 1) * m + j - 1] = true;       
        }
    }

    int left = n * m;
    for (int p = 0 ; p < PEOPLE_SIZE ; ++p)
    {
        if (p == 0 || left == 0)
        {
            chosenRow[p] = n;
            chosenCol[p] = m;
        } else
        {
            int idx = rng() % left + 1;
            int cnt = 0;
            for (int i = 0 ; i < n * m ; ++i) cnt += isOnPath[i];
            // std::cout << "here: " << idx << ' ' << cnt << ' ' << left << '\n' << std::flush;
            assert(idx <= cnt);
            for (int i = 0 ; i < n * m ; ++i)
            {
                idx -= isOnPath[i];
                if (idx == 0)
                {
                    chosenRow[p] = i / m + 1;
                    chosenCol[p] = i % m + 1;
                    break;
                }
            }
            
            assert(chosenRow[p] != 0);
        }

        // std::cout << "choose: " << chosenRow[p] << ' ' << chosenCol[p] << '\n';
        for (int i = chosenRow[p] ; i >= 1 ; --i)
        {
            for (int j = chosenCol[p] ; j >= 1 ; --j)
            {
                dp[p][i][j] = INF;
                if (i == chosenRow[p] && j == chosenCol[p]) dp[p][i][j] = t[i][j];
                if (i < chosenRow[p]) dp[p][i][j] = std::min(dp[p][i][j], t[i][j] + dp[p][i + 1][j]);
                if (j < chosenCol[p]) dp[p][i][j] = std::min(dp[p][i][j], t[i][j] + dp[p][i][j + 1]);
            }
        }

        int row = 1, col = 1;
        while (row < chosenRow[p] || col < chosenCol[p])
        {
            if (isOnPath[(row - 1) * m + col - 1])
            {
                isOnPath[(row - 1) * m + col - 1] = false;
                left--;
            }

            if (row == chosenRow[p])
            {
                col++;
            } else if (col == chosenCol[p])
            {
                row++;
            } else
            {
                if (dp[p][row][col] == t[row][col] + dp[p][row + 1][col]) row++;
                else col++;
            }
        }
    }   

    for (int i = 1 ; i <= q ; ++i)
    {
        int xs, ys, xt, yt;
        std::cin >> xs >> ys >> xt >> yt;
        int ans = -INF;

        for (int p = 0 ; p < PEOPLE_SIZE ; ++p)
        {
            if (xt <= chosenRow[p] && yt <= chosenCol[p])
            {
                ans = std::max(ans, dp[p][xs][ys] - dp[p][xt][yt] + t[xt][yt]);
            }
        }

        std::cout << ans << '\n';
    }
}

void input()
{
    std::cin >> n >> m >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        t[i].resize(m + 1);
        for (int j = 0 ; j < PEOPLE_SIZE ; ++j) dp[j][i].resize(m + 1);
        for (int j = 1 ; j <= m ; ++j)
        {
            std::cin >> t[i][j];
        }
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}