/*
    Nevuzpitano ruso e cveta na kosite
    Silikon v ostata silikon v gurdite
    I parfuima natrapchiv i visoki botushi
    I cigari sled sexa tya obicha da pushi
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <random>
#include <vector>
#include <set>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

typedef tree <int, std::less <int>, null_type, rb_tree_tag, tree_order_statistics_node_update> OSet;

typedef long long llong;
const int MAXN = 200000 + 10;
const int MAXQ = 200000 + 10;
const int PEOPLE_SIZE = 50;
const int INF  = 2e9;

int n, m, q;
struct Query
{
    int xs, ys, xt, yt, idx;
    friend bool operator < (const Query &a, const Query &b)
    {
        if (a.xt != b.xt) return a.xt < b.xt;
        return a.yt < b.yt;
    }
};

bool isOnPath[MAXN];
bool called[MAXN];
std::vector <int> t[MAXN];
std::vector <int> dp[PEOPLE_SIZE][MAXN];
int chosenRow[PEOPLE_SIZE];
int chosenCol[PEOPLE_SIZE];
std::mt19937 rng(69420);
int left;

void dfs(int row, int col, int p)
{
    if (called[(row - 1) * m + col - 1])
    {
        return;
    }
    
    if (isOnPath[(row - 1) * m + col - 1])
    {
        left--;
        isOnPath[(row - 1) * m + col - 1] = false;
    }

    called[(row - 1) * m + col - 1] = true;
    if (row < chosenRow[p] && dp[p][row][col] == t[row][col] + dp[p][row + 1][col]) dfs(row + 1, col, p);
    if (col < chosenCol[p] && dp[p][row][col] == t[row][col] + dp[p][row][col + 1]) dfs(row, col + 1, p);
}

void solve()
{
    for (int i = 0 ; i <= n * m ; ++i)
    {
        isOnPath[i] = true;
    }

    left = n * m;
    for (int p = 0 ; p < PEOPLE_SIZE ; ++p)
    {
        if (left == 0)
        {
            break;
        }

        if (p == 0)
        {
            chosenRow[p] = n;
            chosenCol[p] = m;
        } else
        {
            assert(left > 0);
            int idx = rng() % (left / 2 + 1) + (left - (left / 2 + 1) + 1);
            for (int i = 0 ; i < n * m ; ++i)
            {
                idx -= isOnPath[i];
                if (idx == 0)
                {
                    chosenRow[p] = i / m + 1;
                    chosenCol[p] = i % m + 1;
                    break;
                }
            }
            
            assert(chosenRow[p] != 0);
        }

        for (int i = chosenRow[p] ; i >= 1 ; --i)
        {
            for (int j = chosenCol[p] ; j >= 1 ; --j)
            {
                dp[p][i][j] = INF;
                if (i == chosenRow[p] && j == chosenCol[p]) dp[p][i][j] = t[i][j];
                if (i < chosenRow[p]) dp[p][i][j] = std::min(dp[p][i][j], t[i][j] + dp[p][i + 1][j]);
                if (j < chosenCol[p]) dp[p][i][j] = std::min(dp[p][i][j], t[i][j] + dp[p][i][j + 1]);
            }
        }

        int lastLeft = left;
        std::fill(called, called + n * m, 0);
        if (p < 50) dfs(1, 1, p);
        else dfs(rng() % chosenRow[p] + 1, rng() % chosenCol[p] + 1, p);
    }       

    for (int i = 1 ; i <= q ; ++i)
    {
        int xs, ys, xt, yt;
        std::cin >> xs >> ys >> xt >> yt;
        llong ans = -1e18;

        for (int p = 0 ; p < PEOPLE_SIZE ; ++p)
        {
            if (xt <= chosenRow[p] && yt <= chosenCol[p])
            {
                ans = std::max(ans, (llong)dp[p][xs][ys] - (llong)dp[p][xt][yt] + (llong)t[xt][yt]);
            }
        }

        std::cout << ans << '\n';
    }
}

void input()
{
    std::cin >> n >> m >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        t[i].resize(m + 1);
        for (int j = 0 ; j < PEOPLE_SIZE ; ++j) dp[j][i].resize(m + 1);
        for (int j = 1 ; j <= m ; ++j)
        {
            std::cin >> t[i][j];
        }
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}