#include "gcdSquared.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 200000 + 10;
const int MAXLOG = 18;
const int INF  = 1e9;

int n;
struct Sparse
{
    int sparse[MAXLOG][MAXN];
    int getLOG[MAXN];

    void build(int v[])
    {
        for (int i = 1 ; i < n ; ++i)
        {
            sparse[0][i] = abs(v[i] - v[i + 1]);
        }

        for (int lg = 1 ; (1 << lg) < n ; ++lg)
        {
            for (int i = 1 ; i + (1 << lg) - 1 < n ; ++i)
            {
                sparse[lg][i] = std::__gcd(sparse[lg - 1][i], sparse[lg - 1][i + (1 << lg - 1)]);
            }
        }

        for (int i = 1 ; i < n ; ++i)
        {
            getLOG[i] = getLOG[i - 1];
            if ((1 << getLOG[i] + 1) < i) getLOG[i]++;
        }
    }

    int findGCD(int l, int r)
    {
        if (l > r) return 0;
        int lg = getLOG[r - l + 1];
        return std::__gcd(sparse[lg][l], sparse[lg][r - (1 << lg) + 1]);
    }
};

Sparse sparse;
int v[MAXN];

void init(int _n, const int _v[])
{
    n = _n;
    for (int i = 1 ; i <= n ; ++i)
    {
        v[i] = _v[i];
    }
    
    sparse.build(v);
}

llong getGCD(int a, int b, int c, int l, int r)
{
    llong res = sparse.findGCD(l, r - 1);
    res *= b;
    res = std::__gcd(res, 1LL * b * v[l] + c);

    return res;
}