#include "gcdSquared.h"
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll MAXN=2e5+5;

ll n;
ll x[MAXN];
ll diff[MAXN];
ll diff2[MAXN];

ll tree[4*MAXN];
ll tree2[4*MAXN];

ll query(ll node,ll l,ll r,ll b,ll e)
{
    if(e<l || r<b) return 0;
    if(b<=l && r<=e) return tree[node];
    ll mid=(l+r)/2;
    ll ret=__gcd(query(2*node,l,mid,b,e),
                 query(2*node+1,mid+1,r,b,e));
    return ret;
}

ll query2(ll node,ll l,ll r,ll b,ll e)
{
    if(e<l || r<b) return 0;
    if(b<=l && r<=e) return tree2[node];
    ll mid=(l+r)/2;
    ll ret=__gcd(query2(2*node,l,mid,b,e),
                 query2(2*node+1,mid+1,r,b,e));
    return ret;
}

void build(ll node,ll l,ll r)
{
    if(l==r)
    {
        tree[node]=diff[l];
        return;
    }
    ll mid=(l+r)/2;
    build(2*node,l,mid);
    build(2*node+1,mid+1,r);
    tree[node]=__gcd(tree[2*node],tree[2*node+1]);
}
void build2(ll node,ll l,ll r)
{
    if(l==r)
    {
        tree2[node]=diff2[l];
        return;
    }
    ll mid=(l+r)/2;
    build2(2*node,l,mid);
    build2(2*node+1,mid+1,r);
    tree2[node]=__gcd(tree2[2*node],tree2[2*node+1]);
}

void init(int _n, const int v[])
{
    n=_n;
    for(ll i=1;i<=n;i++) x[i]=v[i];
    for(ll i=1;i<n;i++) diff[i]=abs(x[i]-x[i+1]);
    for(ll i=1;i<n-1;i++) diff2[i]=abs(x[i]-x[i+2]);

    build(1,1,n-1);
    build2(1,1,n-2);
}

long long getGCD(int a, int b, int c, int l, int r)
{
    if(r-l<=1)
    {
        if(l==r) return 1LL*a*x[l]*x[l]+1LL*b*x[l]+c;
        return __gcd(1LL*a*x[l]*x[l]+1LL*b*x[l]+c, 1LL*a*x[r]*x[r]+1LL*b*x[r]+c);
    }

    ll t=__gcd(query2(1,1,n-2,l,r-2), (ll)abs(x[l+1]-x[r]));
    t=__gcd(1LL*a*(x[l]+x[l+1])+1LL*b, 1LL*a*t);

    long long d=query(1,1,n-1,l,r-1);

    long long ans=__gcd(1LL*a*x[l]*x[l]+1LL*b*x[l]+c, 1LL*t*d);

    return ans;
}
