#include <iostream>
#include "gcdSquared.h"
const int MAXN = 2 * 1e5 + 1;
long long arr[MAXN];
long long diff[MAXN];
long long sparse[MAXN][20];
long long logg[MAXN];
long long asb(long long a) {
    if (a < 0) {
        return -a;
    } else {
        return a;
    }
}
long long nod(long long a, long long b) {
    if (a < b) {
        std::swap(a, b);
    }
    if (b == 0) {
        return a;
    }
    return nod(b, a % b);
}
void init(int n, const int v[]) {
    for (int i = 1; i <= n; i++) {
        arr[i] = v[i];
    }
    logg[1] = 0;
    for (int i = 2; i <= n; i++) {
        logg[i] = logg[i - 1];
        if ((1 << (logg[i] + 1)) == i) {
            logg[i]++;
        }
    }
    for (int i = 1; i < n; i++) {
        sparse[i][0] = asb(arr[i + 1] - arr[i]);
    }
    for (int j = 1; (1 << j) <= n - 1; j++) {
        for (int i = 1; i <= n - 1; i++) {
            sparse[i][j] = nod(sparse[i][j - 1], sparse[std::min(i + (1 << (j - 1)), n - 1)][j - 1]);
        }
    }
}
long long getGCD(int a, int b, int c, int l, int r) {
    if (l == r) {
        return a * arr[l] * arr[l] + b * arr[l] + c;
    }
    r--;
    int lg = logg[r - l + 1];
    long long curr = nod(sparse[l][lg], sparse[r - (1 << lg) + 1][lg]);
    long long bas = nod(a, nod(b, c));
    a /= bas;
    b /= bas;
    c /= bas;
    return bas * nod(curr, a * arr[l] * arr[l] + b * arr[l] + c);
}

//int main() {
//    int n;
//    std::cin >> n;
//    for (int i = 1; i <= n; i++) {
//        std::cin >> arr[i];
//    }
//    logg[1] = 0;
//    for (int i = 2; i <= n; i++) {
//        logg[i] = logg[i - 1];
//        if ((1 << (logg[i] + 1)) == i) {
//            logg[i]++;
//        }
//    }
//    for (int i = 1; i < n; i++) {
//        sparse[i][0] = asb(arr[i + 1] - arr[i]);
//    }
//    for (int j = 1; (1 << j) <= n - 1; j++) {
//        for (int i = 1; i <= n - 1; i++) {
//            sparse[i][j] = nod(sparse[i][j - 1], sparse[std::min(i + (1 << (j - 1)), n - 1)][j - 1]);
//        }
//    }
//    int q;
//    std::cin >> q;
//    while (q --> 0) {
//        int a, b, c, l, r;
//        std::cin >> a >> b >> c >> l >> r;
//        std::cout << getGCD(a, b, c, l, r) << '\n';
//    }
//}
