#include <iostream>
#include <random>
#include <vector>
#define endl '\n'
using namespace std;

mt19937 rg(5031491);

const int MAXN = 64;

int cnt = 0;
int pref[MAXN + 5][MAXN + 5];
vector< pair< char, pair<int, int> > > nodes;
int vr[MAXN + 5][MAXN + 5][MAXN + 5][MAXN + 5];

int go(int i0, int j0, int i1, int j1)
{
    if (vr[i0][j0][i1][j1] != 0) return vr[i0][j0][i1][j1];
    if (i0 == i1 or (j1 - j0 >= i1 - i0 and rg() % 5))
    {
        int mid = (j0 + j1) / 2;
        int a = go(i0, j0, i1, mid);
        int b = go(i0, mid + 1, i1, j1);
        cnt++;
        vr[i0][j0][i1][j1] = cnt;
        nodes.push_back({'+', {a, b}});
        return cnt;
    }
    if (j0 == j1 or (i1 - i0 > j1 - j0 and rg() % 5))
    {
        int mid = (i0 + i1) / 2;
        int a = go(i0, j0, mid, j1);
        int b = go(mid + 1, j0, i1, j1);
        cnt++;
        vr[i0][j0][i1][j1] = cnt;
        nodes.push_back({'+', {a, b}});
        return cnt;
    }

    int mid1 = (i0 + i1) / 2;
    int mid2 = (j0 + j1) / 2;
    int a = go(i0, j0, mid1, mid2);
    int b;
    if (vr[i0][j0][mid1][j1] != 0)
    {
        cnt++;
        nodes.push_back({'-', {vr[i0][j0][mid1][j1], a}});
        b = cnt;
    }
    else b = go(i0, mid2 + 1, mid1, j1);
    int c;
    if (vr[i0][j0][i1][mid2] != 0)
    {
        cnt++;
        nodes.push_back({'-', {vr[i0][j0][i1][mid2], a}});
        c = cnt;
    }
    else c = go(mid1 + 1, j0, i1, mid2);
    int d = go(mid1 + 1, mid2 + 1, i1, j1);
    cnt++;
    nodes.push_back({'+', {a, b}});
    cnt++;
    nodes.push_back({'+', {c, d}});
    cnt++;
    vr[i0][j0][i1][j1] = cnt;
    nodes.push_back({'+', {cnt - 2, cnt - 1}});
    return cnt;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m;
    cin >> n >> m;

    cnt = n * m;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            vr[i][j][i][j] = (i - 1) * m + j;
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            go(1, 1, i, j);
            pref[i][j] = vr[1][1][i][j];
        }
    }

    cout << cnt << endl;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            cout << pref[i][j] << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < nodes.size(); ++ i)
    {
        cout << i + n * m + 1 << " = " << nodes[i].second.first << " " << nodes[i].first << " " << nodes[i].second.second << endl;
    }

    return 0;
}
