#include "gcdSquared.h"
///#include "Lgrader.cpp"
#include <algorithm>
#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int n, num[MAXN + 5];
int tree[4 * MAXN + 5];

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = 0;
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    tree[v] = __gcd(tree[2 * v], tree[2 * v + 1]);
    tree[v] = __gcd(tree[v], num[mid + 1] - num[l]);
}

void init(int N, const int v[])
{
    n = N;
    for (int i = 1; i <= n; ++ i)
    {
        num[i] = v[i];
    }
    build(1, 1, n);
}

pair<int, int> query(int v, int l, int r, int ql, int qr)
{
    if (r < ql or qr < l) return {0, -1};
    if (ql <= l and r <= qr) return {tree[v], num[l]};

    int mid = (l + r) / 2;
    auto q1 = query(2 * v, l, mid, ql, qr);
    auto q2 = query(2 * v + 1, mid + 1, r, ql, qr);
    int a = __gcd(q1.first, q2.first);
    if (q1.second != -1 and q2.second != -1) a = __gcd(a, q1.second - q2.second);
    int b = max(q1.second, q2.second);
    return {a, b};
}

long long getGCD(int a, int b, int c, int l, int r)
{
    long long ret = 1ll * (a + b) * query(1, 1, n, l, r).first;
    ret = __gcd(ret, 1ll * num[l] * num[l] * a + 1ll * num[l] * b + c);
    if (ret < 0) ret = -ret;
    return ret;
}
